import time
import sys
import time
sys.path.append("../ei2c")
from ei2c import *


if __name__ == "__main__":
  # Ask for username and password and retry init in case of error
  while 1:
    ip   = raw_input("Crate IP or hostname: ")
    user = raw_input("Username: ")
    pwd  = raw_input("Password: ")
    try:
      testelma = EI2C(ip, user, pwd)
      testelma.open()
      break
    except BadHostnameError as e:
      print(e.strerror)
    except BadUsernameError as e:
      print(e.strerror)
    except BadPasswordError as e:
      print(e.strerror)


  # Wait for proper slot number
  while 1:
    try:
      slot = raw_input("Slot no.: ")
      slot = int(slot)
      break
    except TypeError as e:
      print("Please input a decimal slot number.")
    except SlotError as e:
      print(e.strerror)
    except KeyboardInterrupt:
      sys.exit();
    except:
      print("Unexpected error: ", sys.exc_info()[0])

  # Clear channel counters and close
  testelma.write(slot, 0x0c, 0)
  testelma.write(slot, 0x10, 0)
  testelma.write(slot, 0x14, 0)
  testelma.write(slot, 0x18, 0)
  testelma.write(slot, 0x1c, 0)
  testelma.write(slot, 0x20, 0)
  testelma.close()

