import sys
sys.path.append("../ei2c")
from ei2c import *
import math

if __name__ == "__main__":

	# Ask for username and password and retry init in case of error
	while 1:
		ip   = raw_input("Crate IP or hostname: ")
		user = raw_input("Username: ")
		pwd  = raw_input("Password: ")
		try:
			testelma = EI2C(ip, user, pwd)
			testelma.open()
			break
		except BadHostnameError as e:
			print(e.strerror)
		except BadUsernameError as e:
			print(e.strerror)
		except BadPasswordError as e:
			print(e.strerror)


	# Wait for proper slot number
	while 1:
		try:
			slot = raw_input("Slot no.: ")
			slot = int(slot)
			break
		except TypeError as e:
			print("Please input a decimal slot number.")
		except SlotError as e:
			print(e.strerror)
		except KeyboardInterrupt:
			sys.exit();
		except:
			print("Unexpected error: ", sys.exc_info()[0])

	# Read while FIFO is not empty
	csr   = testelma.read(slot, 0x3c)
	empty = csr & (1 << 17)
	used  = csr & 0x7f

	while not empty:
		# Get channel mask from meta register and convert it to channel number
		ch = testelma.read(slot, 0x2c) & 0x3f
		ch = 1 + int(math.log(ch)/math.log(2))

		# Read cycles and seconds counters
		cyc = testelma.read(slot, 0x30)
		sl  = testelma.read(slot, 0x34)
		sh  = testelma.read(slot, 0x38)

		# The seconds counter indicates actual seconds; the cycles counter
		# indicates 8-ns cycles, so convert to ns
		s   = (sh << 32) | sl
		ns  = cyc*8

		# And print
		csr   = testelma.read(slot, 0x3c)
		empty = csr & (1 << 17)
		used  = csr & 0x7f
		print("(%3d) ch %d: %d.%09d sec" % (used, ch, s, ns))

