import sys
sys.path.append("../ei2c")
import time
from ei2c import *


if __name__ == "__main__":

  # Ask for username and password and retry init in case of error
  while 1:
    ip   = raw_input("Crate IP or hostname: ")
    user = raw_input("Username: ")
    pwd  = raw_input("Password: ")
    try:
      testelma = EI2C(ip, user, pwd)
      testelma.open()
      break
    except BadHostnameError as e:
      print(e.strerror)
    except BadUsernameError as e:
      print(e.strerror)
    except BadPasswordError as e:
      print(e.strerror)


  # Wait for proper slot number
  while 1:
    try:
      slot = raw_input("Slot no.: ")
      slot = int(slot)
      break
    except TypeError as e:
      print("Please input a decimal slot number.")
    except SlotError as e:
      print(e.strerror)
    except KeyboardInterrupt:
      sys.exit();
    except:
      print("Unexpected error: ", sys.exc_info()[0])

  # Set time stamp, close and exit
  s = int(raw_input("Number of seconds: "))
  testelma.write(slot, 0x24, s & 0xffffffff)
  if s > 2**32-1:
    testelma.write(slot, 0x28, s >> 32)

  testelma.close()

